<template>
    <div>
        <v-list-group class="group-title bordered" style="margin-bottom: 10%;">
            <template v-slot:activator>
                <v-list-item-title>Categorias</v-list-item-title>
            </template>
            <template v-slot:prependIcon>
                <HexButton class="action" :alwaysOn="true" @click="initCategoryDialog">
                    <v-icon>mdi-plus</v-icon>
                </HexButton>
            </template>

            <div class="box overflow-y-auto" style="max-height: 400px;">
                <v-list-item v-for="category in categoriesMenu" :key="category.id" class="group-content bordered">
                    <v-list-item-content class="ml-10" v-text="category.name"></v-list-item-content>

                    <span class="mr-5">{{ category.lastUpdated.toDate().toLocaleString() }}</span>
                    <span>EDITAR</span>
                    <HexButton class="small-button" @click="initCategoryDialog($event, category)">
                        <v-icon>mdi-pencil</v-icon>
                    </HexButton>
                    <span class="ml-10">ELIMINAR</span>
                    <HexButton class="small-button" @click="deleteCategory(category)">
                        <v-icon>mdi-delete</v-icon>
                    </HexButton>
                </v-list-item>
                <v-list-item v-if="!categoriesMenu.length" class="group-content bordered">
                    <v-spacer></v-spacer>
                    <v-list-item-content style="font-size:10px;"></v-list-item-content>
                </v-list-item>
            </div>
        </v-list-group>
        <category
            :categories="categories"
            :category="category"
            :subcategory="subcategory"
            :langs-menu="langsMenu"
            :dialog="showCategoryDialog"
            :menu-id="menuId"
            @setShowCategoryModal="setShowCategoryModal"
            @saveCategory="saveCategory"
            @setMessage="setMessage"
        ></category>
        <v-dialog v-model="message.show" rounded="" max-width="290">
            <v-alert
                style="text-align:center; margin:0;"
                justify="center"
                v-model="message.show"
                dismissible
                :type="message.type"
                >{{ message.message }}</v-alert
            >
        </v-dialog>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { Category as CategoryModel } from '../../model/menu/Category';
import { Subcategory as SubCategoryModel } from '@/model/menu/Subcategory';
import Category from '@/components/menu/Category.vue';
import { LangMenu } from '@/model/menu/LangMenu';
import { CategoryService } from '@/services/CategoryService';
import { LangText } from '@/model/LangText';
import HexButton from '@/components/commons/HexButton.vue';
import { newTimestamp } from '@/config/serializables';

@Component({
    components: {
        Category,
        HexButton
    }
})
export default class Categories extends Vue {
    @Prop({ default: () => [] })
    categories!: CategoryModel[];
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ required: true })
    menuId!: string;

    category = new CategoryModel('', false, '',false,0,'', 0, newTimestamp());
    categoryService = new CategoryService();
    showCategoryDialog = false;
    subcategory = new SubCategoryModel('', false, '', '', 0);

    message: { message: string; type: 'success' | 'info' | 'warning' | 'error'; show: boolean } = {
        message: '',
        type: 'error',
        show: false
    };

    get categoriesMenu() {
        return this.categories;
    }

    initCategoryDialog(event: Event, cat?: CategoryModel) {
        if (!cat) {
            cat = new CategoryModel('', false, '', false,0, '', 0, newTimestamp());
        }
        this.category = cat;
        this.showCategoryDialog = true;
    }

    setShowCategoryModal(show: boolean) {
        this.showCategoryDialog = show;
    }

    async saveCategory(cat: CategoryModel, langsCategory: LangText[], fileIconCategory: File) {
        // console.log('entre al metodos', fileIconCategory);

        if (cat.id) {
            await this.categoryService.updtaeMenuCategory(this.menuId, cat, langsCategory, fileIconCategory);
            this.$emit('setMessage', 'CATEGORIA ACTUALIZADA', 'success');
            return;
        }
        await this.categoryService.createMenuCategory(this.menuId, cat, langsCategory, fileIconCategory);
        this.$emit('setMessage', 'CATEGORIA CREADA', 'success');
        return;
    }

    async deleteCategory(cat: CategoryModel) {
        await this.categoryService.deleteMenuCategory(this.menuId, cat);
        this.$emit('setMessage', 'CATEGORIA ELIMINADA', 'info');
        return;
    }
    setMessage(message: string, type: 'success' | 'info' | 'warning' | 'error') {
        this.message = { message, type, show: true };
    }
}
</script>

<style lang="scss" scoped>
.box::-webkit-scrollbar {
    width: 100%;
    margin-bottom: 5%;
    display: none;
}
</style>
